﻿using System;
using System.Drawing;
using System.Windows.Forms;

using Steema.TeeChart.Drawing;
using Steema.TeeChart.Styles;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Load += Form_Load;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            this.tChart.Aspect.Chart3DPercent = 50; 

            this.tChart.AfterDraw += tChart_AfterDraw;

            Line line = new Line(this.tChart.Chart);

            line.HorizAxis = HorizontalAxis.Both;
            line.VertAxis  = VerticalAxis.Both;

            line.FillSampleValues(20);
        }
        
        #endregion
        #region 티차트 그리기 후 처리하기 - tChart_AfterDraw(sender, graphics3D)

        /// <summary>
        /// 티차트 그리기 후 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="graphics3D">이벤트 인자</param>
        private void tChart_AfterDraw(object sender, Graphics3D graphics3D)
        {
            string text = "테스트 텍스트";
            
            Size      size         = new Size(150, 50);
            Point     leftTopPoint = new Point(graphics3D.ChartXCenter - (size.Width / 2), graphics3D.ChartYCenter - (size.Height / 2));
            Rectangle rectangle    = new Rectangle(leftTopPoint,size);

            graphics3D.Pen.Color = Color.Blue;

            graphics3D.Rectangle(rectangle, this.tChart.Aspect.Width3D / 2);

            graphics3D.TextOut
            (
                Convert.ToInt32(graphics3D.ChartXCenter - (graphics3D.TextWidth (text) / 2)),
                Convert.ToInt32(graphics3D.ChartYCenter - (graphics3D.TextHeight(text) / 2)),
                this.tChart.Aspect.Width3D / 2,
                text
            );
        }

        #endregion
    }
}